// Martin Thomas 4/2008

#ifndef PORT_EXT_H
#define PORT_EXT_H

#define PORT_EXT_OUTPORTS   3  /* num. of 74x595 */

/* BC100 U202:
   reset ATtinyx61          (Q0)
   reset ATtinyx5           (Q1)
   power-off = 1 = disabled (Q2)
   electronic load- off     (Q4)
   electronic load+ off     (Q6) */
#define PORT_EXT_INIT0      ( (1<<0)|(1<<1)|(1<<2)|(1<<4)|(1<<6) )
#define PORT_EXT_INIT1      0x00
#define PORT_EXT_INIT2      0x00

#define PORT_EXT_PORT       PORTB
#define PORT_EXT_DDR        DDRB
#define PORT_EXT_PIN        PINB
#define PORT_EXT_PIN_OE     PB0  /* = /OE   */
#define PORT_EXT_PIN_LATCH  PB1  /* = ST_CP */
#define PORT_EXT_PIN_DIN    PB2  /* = DS    */
#define PORT_EXT_PIN_CLK    PB3  /* = SH_CP */

void port_ext_init(void);
void port_ext_update(void);
void port_ext_bit_clear( uint8_t port, uint8_t bit );
void port_ext_bit_set( uint8_t port, uint8_t bit );
void port_ext_set( uint8_t port, uint8_t val );

#endif
