// Martin Thomas 3/2008

#include <stdint.h>
#include <avr/io.h>
#include <util/delay.h>

#include "spi.h"

void SPI_init( void )
{
	SPI_PORT |= (1<<SPI_MISO_BIT) | ( 1<<SPI_SS_BIT); // enable pull-up input and SS default high
	SPI_PORT &= ~( (1<<SPI_SCK_BIT) | (1<<SPI_MOSI_BIT) ); // output-inits
	SPI_DDR  &= ~(1<<SPI_MISO_BIT);
	SPI_DDR  |= (1<<SPI_MOSI_BIT) | (1<<SPI_SCK_BIT) | (1<<SPI_SS_BIT);		//Set MOSI, SCK AND SS as outputs
	// SPSR = (1<<SPI2X);
	SPCR = (1<<SPE) | (1<<MSTR) | ( 1<<SPR1) | ( 1<<SPR0 );
}

void SPI_release( void )
{
	SPCR = 0;
	SPI_DDR  &= ~( (1<<SPI_MOSI_BIT) | (1<<SPI_SCK_BIT) | (1<<SPI_SS_BIT ) );
	SPI_PORT &= ~( (1<<SPI_MISO_BIT) | ( 1<<SPI_SS_BIT) );
}

uint8_t SPI_rw( uint8_t out )
{
	uint8_t in;

	_delay_ms(1); // slow down to give slave time to process

#if defined(SPDR0)
	SPDR0 = out;
	while( !(SPSR0 & (1<<SPIF0)) ) { ; }
	in = SPDR0;
#else
	SPDR = out;
	while( !(SPSR & (1<<SPIF)) ) { ; }
	in = SPDR;
#endif
	return in;
}

